#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ChannelVariableComputeExpressionInputDataType {
    #[serde(rename = "NUMERIC_SERIES")]
    NumericSeries,
    #[serde(rename = "ENUM_SERIES")]
    EnumSeries,
    #[serde(rename = "RANGE_SERIES")]
    RangeSeries,
    #[serde(rename = "BOOLEAN_SERIES")]
    BooleanSeries,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ChannelVariableComputeExpressionInputDataType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ChannelVariableComputeExpressionInputDataType::NumericSeries => {
                "NUMERIC_SERIES"
            }
            ChannelVariableComputeExpressionInputDataType::EnumSeries => "ENUM_SERIES",
            ChannelVariableComputeExpressionInputDataType::RangeSeries => "RANGE_SERIES",
            ChannelVariableComputeExpressionInputDataType::BooleanSeries => {
                "BOOLEAN_SERIES"
            }
            ChannelVariableComputeExpressionInputDataType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ChannelVariableComputeExpressionInputDataType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ChannelVariableComputeExpressionInputDataType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ChannelVariableComputeExpressionInputDataType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<
        ChannelVariableComputeExpressionInputDataType,
        conjure_object::plain::ParseEnumError,
    > {
        match v {
            "NUMERIC_SERIES" => {
                Ok(ChannelVariableComputeExpressionInputDataType::NumericSeries)
            }
            "ENUM_SERIES" => {
                Ok(ChannelVariableComputeExpressionInputDataType::EnumSeries)
            }
            "RANGE_SERIES" => {
                Ok(ChannelVariableComputeExpressionInputDataType::RangeSeries)
            }
            "BOOLEAN_SERIES" => {
                Ok(ChannelVariableComputeExpressionInputDataType::BooleanSeries)
            }
            v => {
                v.parse()
                    .map(|v| ChannelVariableComputeExpressionInputDataType::Unknown(
                        Unknown(v),
                    ))
            }
        }
    }
}
impl conjure_object::FromPlain for ChannelVariableComputeExpressionInputDataType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<
        ChannelVariableComputeExpressionInputDataType,
        conjure_object::plain::ParseEnumError,
    > {
        v.parse()
    }
}
///An unknown variant of the ChannelVariableComputeExpressionInputDataType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
